ChunkedInputFilter (Apache Tomcat 10.1.48 API Documentation)
Description: declaration: package: org.apache.coyote.http11.filters, class: ChunkedInputFilter

# Class ChunkedInputFilter

java.lang.Object
org.apache.coyote.http11.filters.ChunkedInputFilter

All Implemented Interfaces:
  `InputFilter, InputBuffer, HttpHeaderParser.HeaderDataSource, ApplicationBufferHandler`

public class ChunkedInputFilter extends Object implements InputFilter, ApplicationBufferHandler, HttpHeaderParser.HeaderDataSource
Chunked input filter. Parses chunked data according to http://www.w3.org/Protocols/rfc2616/rfc2616-sec3.html#sec3.6.1

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected InputBuffer`
  `buffer`
  Next buffer in the pipeline.
  `protected static final ByteChunk`
  `ENCODING`
  `protected static final String`
  `ENCODING_NAME`
  `protected ByteBuffer`
  `readChunk`
  Byte chunk used to read bytes.
  `protected int`
  `remaining`
  Number of bytes remaining in the current chunk.
  `protected final ByteBuffer`
  `trailingHeaders`
  Buffer used to store trailing headers.

  ### Fields inherited from interface ApplicationBufferHandler

  `EMPTY, EMPTY_BUFFER`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ChunkedInputFilter(Request request, int maxTrailerSize, Set<String> allowedTrailerHeaders, int maxExtensionSize, int maxSwallowSize)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `available()`
  Obtain an estimate of the number of bytes that can be read without blocking.
  `int`
  `doRead(ApplicationBufferHandler handler)`
  Read from the input stream into the ByteBuffer provided by the ApplicationBufferHandler.
  `long`
  `end()`
  End the current request.
  `void`
  `expand(int size)`
  Expand the byte buffer to at least the given size.
  `boolean`
  `fillHeaderBuffer()`
  Read more data into the header buffer.
  `ByteBuffer`
  `getByteBuffer()`
  `ByteChunk`
  `getEncodingName()`
  Get the name of the encoding handled by this filter.
  `ByteBuffer`
  `getHeaderByteBuffer()`
  Obtain a reference to the buffer containing the header data.
  `boolean`
  `isFinished()`
  Has the request body been read fully?
  `protected int`
  `readBytes()`
  Read bytes from the previous buffer.
  `void`
  `recycle()`
  Make the filter ready to process the next request.
  `void`
  `setBuffer(InputBuffer buffer)`
  Set the next buffer in the filter pipeline.
  `void`
  `setByteBuffer(ByteBuffer buffer)`
  Set the byte buffer.
  `void`
  `setRequest(Request request)`
  Some filters need additional parameters from the request.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### ENCODING_NAME

    protected static final String ENCODING_NAME
    See Also:
      - Constant Field Values

  - ### ENCODING

    protected static final ByteChunk ENCODING

  - ### buffer

    protected InputBuffer buffer
    Next buffer in the pipeline.

  - ### remaining

    protected int remaining
    Number of bytes remaining in the current chunk.

  - ### readChunk

    protected ByteBuffer readChunk
    Byte chunk used to read bytes.

  - ### trailingHeaders

    protected final ByteBuffer trailingHeaders
    Buffer used to store trailing headers. Is normally in read mode.

- ## Constructor Details

  - ### ChunkedInputFilter

    public ChunkedInputFilter(Request request, int maxTrailerSize, Set<String> allowedTrailerHeaders, int maxExtensionSize, int maxSwallowSize)

- ## Method Details

  - ### doRead

    public int doRead(ApplicationBufferHandler handler) throws IOException
    Description copied from interface: `InputBuffer`
    Read from the input stream into the ByteBuffer provided by the ApplicationBufferHandler. IMPORTANT: the current model assumes that the protocol will 'own' the ByteBuffer and return a pointer to it.
    Specified by:
      `doRead` in interface `InputBuffer`
    Parameters:
      `handler` - ApplicationBufferHandler that provides the buffer to read data into.
    Returns:
      The number of bytes that have been added to the buffer or -1 for end of stream
    Throws:
      `IOException` - If an I/O error occurs reading from the input stream

  - ### setRequest

    public void setRequest(Request request)
    Description copied from interface: `InputFilter`
    Some filters need additional parameters from the request.
    Specified by:
      `setRequest` in interface `InputFilter`
    Parameters:
      `request` - The request to be associated with this filter

  - ### end

    public long end() throws IOException
    Description copied from interface: `InputFilter`
    End the current request.
    Specified by:
      `end` in interface `InputFilter`
    Returns:
      0 is the expected return value. A positive value indicates that too many bytes were read. This method is allowed to use buffer.doRead to consume extra bytes. The result of this method can't be negative (if an error happens, an IOException should be thrown instead).
    Throws:
      `IOException` - If an error happens

  - ### available

    public int available()
    Description copied from interface: `InputBuffer`
    Obtain an estimate of the number of bytes that can be read without blocking. Typically, this will be the number of available bytes known to be buffered.
    Specified by:
      `available` in interface `InputBuffer`
    Returns:
      The number of bytes that can be read without blocking

  - ### setBuffer

    public void setBuffer(InputBuffer buffer)
    Description copied from interface: `InputFilter`
    Set the next buffer in the filter pipeline.
    Specified by:
      `setBuffer` in interface `InputFilter`
    Parameters:
      `buffer` - The next buffer

  - ### recycle

    public void recycle()
    Description copied from interface: `InputFilter`
    Make the filter ready to process the next request.
    Specified by:
      `recycle` in interface `InputFilter`

  - ### getEncodingName

    public ByteChunk getEncodingName()
    Description copied from interface: `InputFilter`
    Get the name of the encoding handled by this filter.
    Specified by:
      `getEncodingName` in interface `InputFilter`
    Returns:
      The encoding name as a byte chunk to facilitate comparison with the value read from the HTTP headers which will also be a ByteChunk

  - ### isFinished

    public boolean isFinished()
    Description copied from interface: `InputFilter`
    Has the request body been read fully?
    Specified by:
      `isFinished` in interface `InputFilter`
    Returns:
      `true` if the request body has been fully read, otherwise `false`

  - ### readBytes

    protected int readBytes() throws IOException
    Read bytes from the previous buffer.
    Returns:
      The byte count which has been read
    Throws:
      `IOException` - Read error

  - ### fillHeaderBuffer

    public boolean fillHeaderBuffer() throws IOException
    Description copied from interface: `HttpHeaderParser.HeaderDataSource`
    Read more data into the header buffer. The implementation is expected to determine if blocking or not blocking IO should be used.
    Specified by:
      `fillHeaderBuffer` in interface `HttpHeaderParser.HeaderDataSource`
    Returns:
      `true` if more data was added to the buffer, otherwise `false`
    Throws:
      `IOException` - If an I/O error occurred while obtaining more header data

  - ### setByteBuffer

    public void setByteBuffer(ByteBuffer buffer)
    Description copied from interface: `ApplicationBufferHandler`
    Set the byte buffer.
    Specified by:
      `setByteBuffer` in interface `ApplicationBufferHandler`
    Parameters:
      `buffer` - the byte buffer

  - ### getByteBuffer

    public ByteBuffer getByteBuffer()
    Specified by:
      `getByteBuffer` in interface `ApplicationBufferHandler`
    Returns:
      the byte buffer

  - ### getHeaderByteBuffer

    public ByteBuffer getHeaderByteBuffer()
    Description copied from interface: `HttpHeaderParser.HeaderDataSource`
    Obtain a reference to the buffer containing the header data.
    Specified by:
      `getHeaderByteBuffer` in interface `HttpHeaderParser.HeaderDataSource`
    Returns:
      The buffer containing the header data

  - ### expand

    public void expand(int size)
    Description copied from interface: `ApplicationBufferHandler`
    Expand the byte buffer to at least the given size. Some implementations may not implement this.
    Specified by:
      `expand` in interface `ApplicationBufferHandler`
    Parameters:
      `size` - the desired size